#include <libfawk/libfawk.h>

/* Create an empty array in dst */
FAWK_API void fawk_array_init(fawk_ctx_t *ctx, fawk_cell_t *dst);

/* Destroy the array in dst: free all indices and values */
FAWK_API void fawk_array_free(fawk_ctx_t *ctx, fawk_cell_t *dst);

/* Allocate and build a list of all indices of an array, load out_len
   with the size of the list */
FAWK_API fawk_arridx_t *fawk_array_dump_list(fawk_ctx_t *ctx, fawk_cell_t *arrcell, size_t *out_len);

/* Convenience call for C applications to retrieve an array member; the
   vararg part is a list of fawk_celltype_t and index pairs, terminated
   by a FAWK_NIL. Non-existent index is created if create is non-zero.
   Returns NULL if create==0 and the index does not exist.
   For example:

   fawk_array_resolve_c(ctx, 1, arr, FAWK_NUM, (fawk_num_t)(n-offs), FAWK_NIL);
*/
FAWK_API fawk_cell_t *fawk_array_resolve_c(fawk_ctx_t *ctx, int create, fawk_cell_t *arrcell, ...);
